'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

/**
 * Created by xy on 15/4/13.
 */
var assign = require('object-assign');
// const Const = require('uxcore-const');
var Tooltip = require('uxcore-tooltip');
var classnames = require('classnames');
var React = require('react');
var addEventListener = require('rc-util/lib/Dom/addEventListener');
addEventListener = addEventListener["default"] || addEventListener;
var CheckBox = require('../Cell/CheckBox');
var util = require('../util');

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header(props) {
    _classCallCheck(this, Header);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      pickerDisplay: false
    };
    return _this;
  }

  Header.prototype.componentDidMount = function componentDidMount() {
    var me = this;
    var fixedColumn = me.props.fixedColumn;

    if (fixedColumn === 'scroll') {
      me.rootEl = me.root;
      me.scrollHandler = me.onScroll.bind(me);
      me.scrollListener = addEventListener(me.rootEl, 'scroll', me.scrollHandler);
    }
  };

  Header.prototype.componentWillUnmount = function componentWillUnmount() {
    var me = this;
    me.scrollListener.remove();
  };

  Header.prototype.onScroll = function onScroll() {
    var me = this;
    var fixedColumn = me.props.fixedColumn;

    if (me.scrollEndTimer) {
      clearTimeout(me.scrollEndTimer);
    }
    me.scrollEndTimer = setTimeout(function () {
      me.props.onScroll(me.rootEl.scrollLeft, me.rootEl.scrollTop, fixedColumn);
    }, 500);
    me.props.onScroll(me.rootEl.scrollLeft, me.rootEl.scrollTop, fixedColumn);
  };

  Header.prototype.getDom = function getDom() {
    return this.root;
  };

  Header.prototype.saveRef = function saveRef(refName) {
    var me = this;
    return function (c) {
      me[refName] = c;
    };
  };

  Header.prototype.handleColumnOrder = function handleColumnOrder(column) {
    var me = this;
    var _me$props = me.props,
        orderColumnCB = _me$props.orderColumnCB,
        activeColumn = _me$props.activeColumn,
        orderType = _me$props.orderType;

    var type = 'desc';
    var typeMap = {
      desc: 'asc',
      asc: 'none',
      none: 'desc'
    };
    if (activeColumn && column.dataKey === activeColumn.dataKey && orderType) {
      type = typeMap[orderType];
    }
    if (orderColumnCB) {
      orderColumnCB(type, column);
    }
  };

  Header.prototype.handleCheckBoxChange = function handleCheckBoxChange(e) {
    var v = e.target.checked;
    this.props.selectAll.apply(null, [v]);
  };

  Header.prototype.renderOrderIcon = function renderOrderIcon(column) {
    var me = this;
    var _me$props2 = me.props,
        orderType = _me$props2.orderType,
        activeColumn = _me$props2.activeColumn;

    if (column.ordered) {
      var _classnames, _classnames2;

      var desc = 'triangle-down';
      var asc = 'triangle-up';
      var isActive = activeColumn && activeColumn.dataKey === column.dataKey;
      return React.createElement(
        'span',
        { className: 'kuma-uxtable-h-sort', onClick: me.handleColumnOrder.bind(me, column) },
        React.createElement('i', {
          className: classnames((_classnames = {}, _defineProperty(_classnames, 'kuma-icon kuma-icon-' + asc, true), _defineProperty(_classnames, 'active', isActive && orderType === 'asc'), _classnames))
        }),
        React.createElement('i', {
          className: classnames((_classnames2 = {}, _defineProperty(_classnames2, 'kuma-icon kuma-icon-' + desc, true), _defineProperty(_classnames2, 'active', isActive && orderType === 'desc'), _classnames2))
        })
      );
    }
    return null;
  };

  Header.prototype.renderMessageIcon = function renderMessageIcon(column) {
    if (!column.message) {
      return null;
    }
    return React.createElement(
      Tooltip,
      {
        overlay: React.createElement(
          'div',
          { className: 'kuma-uxtable-column-message' },
          column.message
        ),
        placement: 'top'
      },
      React.createElement('i', { className: 'kuma-icon kuma-icon-information' })
    );
  };

  Header.prototype.renderColumn = function renderColumn(item, index, hasGroup, last) {
    var me = this;
    var renderModel = me.props.renderModel;

    var rowSelectorInTreeMode = ['checkboxSelector', 'radioSelector'].indexOf(item.type) !== -1 && renderModel === 'tree';
    if (item.hidden || rowSelectorInTreeMode) {
      me.firstIndex = index + 1;
      return null;
    }
    var noBorderColumn = ['jsxchecked', 'jsxtreeIcon', 'jsxwhite'];
    var style = {
      width: item.width ? item.width : 100,
      textAlign: item.align ? item.align : 'left'
    };
    var v = void 0;
    if (hasGroup) {
      assign(style, {
        height: 100,
        lineHeight: '100px'
      });
    }

    if (item.type === 'checkbox' || item.type === 'checkboxSelector') {
      assign(style, {
        paddingRight: 4,
        paddingLeft: 12,
        width: item.width ? item.width : 92
      });

      var checkBoxProps = {
        ref: me.saveRef('checkbox'),
        checked: me.props.checkStatus.isAllChecked,
        halfChecked: me.props.checkStatus.isHalfChecked,
        disable: me.props.checkStatus.isAllDisabled,
        onChange: me.handleCheckBoxChange.bind(me)
      };

      v = React.createElement(CheckBox, checkBoxProps);
    } else {
      var content = typeof item.title === 'function' ? item.title() : item.title;
      var title = typeof item.title === 'function' ? undefined : item.title;
      v = React.createElement(
        'span',
        { title: title },
        content
      );
    }

    if (noBorderColumn.indexOf(item.dataKey) !== -1 || last) {
      assign(style, {
        borderRight: 'none'
      });
    }

    return React.createElement(
      'div',
      {
        key: index,
        className: classnames({
          'kuma-uxtable-cell': true,
          'show-border': me.props.showHeaderBorder
        }),
        style: style
      },
      me.renderIndent(index),
      v,
      me.renderMessageIcon(item),
      me.renderOrderIcon(item)
    );
  };

  Header.prototype.renderIndent = function renderIndent(index) {
    if (this.firstIndex !== index) {
      return null;
    }
    var me = this;
    var _me$props3 = me.props,
        renderModel = _me$props3.renderModel,
        checkboxColumnKey = _me$props3.checkboxColumnKey;

    if (renderModel === 'tree') {
      return React.createElement('span', {
        className: classnames({
          indent: true,
          hasCheck: checkboxColumnKey
        })
      });
    }
    return null;
  };

  Header.prototype.renderColumns = function renderColumns(_columns) {
    var me = this;
    var columns = _columns.map(function (item, index) {
      var last = index === _columns.length - 1;
      if ({}.hasOwnProperty.call(item, 'columns') && _typeof(item.columns) === 'object') {
        // First determine whether the group should be rendered, if all columns
        // is hidden, the column group should not be rendered.
        var shouldRenderGroup = item.columns.some(function (column) {
          return !column.hidden;
        });
        if (shouldRenderGroup) {
          return React.createElement(
            'div',
            { className: 'kuma-uxtable-header-column-group', key: index },
            React.createElement(
              'div',
              { className: 'kuma-uxtable-header-group-name' },
              item.group
            ),
            item.columns.map(function (column, i) {
              return me.renderColumn(column, i, false, last);
            })
          );
        }
        return null;
      }
      return me.renderColumn(item, index, me.hasGroup, last);
    });
    return columns;
  };

  Header.prototype.render = function render() {
    var props = this.props;
    var me = this;
    var headerStyle = {};
    var leftFixedType = ['checkboxSelector', 'radioSelector', 'treeIcon'];
    var scrollBarWidth = util.measureScrollbar();
    var width = 0;
    var headerWrapClassName = void 0;
    var columns = void 0;

    if (props.fixedColumn === 'fixed') {
      columns = props.columns.filter(function (item) {
        if (item.fixed && !item.hidden || leftFixedType.indexOf(item.type) !== -1) {
          width = parseInt(item.width, 10) + width;
          return true;
        }
        return false;
      });
      headerWrapClassName = 'kuma-uxtable-header-fixed';
    } else if (props.fixedColumn === 'rightFixed') {
      columns = props.columns.filter(function (item) {
        if (item.rightFixed && !item.hidden) {
          width = parseInt(item.width, 10) + width;
          return true;
        }
        return false;
      });
      headerWrapClassName = 'kuma-uxtable-header-right-fixed';
    } else if (props.fixedColumn === 'scroll') {
      var leftFixedColumns = [];
      var normalColumns = [];
      var rightFixedColumns = [];
      props.columns.forEach(function (item) {
        if (!item.hidden) {
          if (item.fixed || leftFixedType.indexOf(item.type) !== -1) {
            leftFixedColumns.push(item);
          } else if (item.rightFixed) {
            rightFixedColumns.push(item);
          } else {
            normalColumns.push(item);
          }
        }
      });

      columns = leftFixedColumns.concat(normalColumns, rightFixedColumns);

      assign(headerStyle, {
        marginBottom: '-' + scrollBarWidth + 'px',
        overflowX: scrollBarWidth ? 'scroll' : 'hidden'
        // width: typeof props.width === 'number' ? props.width - 3 : props.width,
        // minWidth: typeof props.width === 'number' ? props.width - 3 : props.width,
      });
      headerWrapClassName = 'kuma-uxtable-header-scroll';
    } else {
      columns = props.columns;
      headerWrapClassName = 'kuma-uxtable-header-no';
    }
    me.hasGroup = false;
    for (var i = 0; i < columns.length; i++) {
      if ('group' in columns[i]) {
        me.hasGroup = true;
        break;
      }
    }
    return React.createElement(
      'div',
      { className: headerWrapClassName, style: headerStyle, ref: me.saveRef('root') },
      React.createElement(
        'div',
        { className: props.prefixCls },
        me.renderColumns(columns)
      )
    );
  };

  return Header;
}(React.Component);

Header.propTypes = {
  handleColumnPickerChange: React.PropTypes.func,
  selectAll: React.PropTypes.func
};

Header.defaultProps = {
  prefixCls: 'kuma-uxtable-header'
};

module.exports = Header;