'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

/**
 * Created by xy on 15/4/13.
 */

var Row = require('./Row');
var util = require('./util');
var deepcopy = require('lodash/cloneDeep');
var React = require('react');
var addEventListener = require('rc-util/lib/Dom/addEventListener');
// const throttle = require('lodash/throttle');
var EmptyData = require('uxcore-empty-data');
// const QueueAnim = require('rc-queue-anim');
addEventListener = addEventListener["default"] || addEventListener;

var Tbody = function (_React$Component) {
  _inherits(Tbody, _React$Component);

  function Tbody(props) {
    _classCallCheck(this, Tbody);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {};
    return _this;
  }

  Tbody.prototype.componentDidMount = function componentDidMount() {
    var me = this;
    me.rootEl = me.root;
    me.scrollHandler = me.onScroll.bind(me);
    me.scrollListener = addEventListener(me.rootEl, 'scroll', me.scrollHandler);
  };

  Tbody.prototype.componentWillUnmount = function componentWillUnmount() {
    var me = this;
    me.scrollListener.remove();
  };

  Tbody.prototype.onScroll = function onScroll() {
    var me = this;
    var fixedColumn = me.props.fixedColumn;

    if (me.scrollEndTimer) {
      clearTimeout(me.scrollEndTimer);
    }
    me.scrollEndTimer = setTimeout(function () {
      me.props.onScroll(me.rootEl.scrollLeft, me.rootEl.scrollTop, fixedColumn);
    }, 500);
    me.props.onScroll(me.rootEl.scrollLeft, me.rootEl.scrollTop, fixedColumn);
  };

  Tbody.prototype.getDom = function getDom() {
    return this.root;
  };

  Tbody.prototype.saveRef = function saveRef(name) {
    var me = this;
    return function func(c) {
      me[name] = c;
    };
  };

  Tbody.prototype.renderEmptyData = function renderEmptyData() {
    if (this.props.data.length === 0 && !this.props.mask) {
      var style = {};
      if (typeof this.props.height === 'number') {
        style.lineHeight = this.props.height - 10 + 'px';
      }
      return React.createElement(
        EmptyData,
        { style: { marginTop: '20px', marginBottom: '20px' } },
        this.props.emptyText
      );
    }
    return null;
  };

  Tbody.prototype.render = function render() {
    var me = this;
    var props = me.props;
    var data = props.data;
    var leftFixedType = ['checkboxSelector', 'radioSelector', 'treeIcon'];
    var style = {
      height: props.bodyHeight
    };
    var columns = deepcopy(props.columns);
    var width = 0;
    var bodyWrapClassName = void 0;

    var scrollBarWidth = util.measureScrollbar();

    if (props.fixedColumn === 'fixed') {
      columns = props.columns.filter(function (item) {
        if (item.fixed && !item.hidden || leftFixedType.indexOf(item.type) !== -1) {
          width = parseInt(item.width, 10) + width;
          return true;
        }
        return false;
      });
      style = _extends({}, style, {
        // paddingBottom: `${scrollBarWidth}px`,
        // marginBottom: `-${scrollBarWidth}px`,
        height: props.bodyHeight === 'auto' ? props.bodyHeight : props.bodyHeight - scrollBarWidth + 'px'
      });

      bodyWrapClassName = 'kuma-uxtable-body-fixed';
    } else if (props.fixedColumn === 'rightFixed') {
      columns = props.columns.filter(function (item) {
        if (item.rightFixed && !item.hidden) {
          return true;
        }
        return false;
      });
      bodyWrapClassName = 'kuma-uxtable-body-right-fixed';
      style = _extends({}, style, {
        // paddingBottom: `${scrollBarWidth}px`,
        // marginBottom: `-${scrollBarWidth}px`,
        height: props.bodyHeight === 'auto' ? props.bodyHeight : props.bodyHeight - scrollBarWidth + 'px'
      });
    } else if (props.fixedColumn === 'scroll') {
      var leftFixedColumns = [];
      var normalColumns = [];
      var rightFixedColumns = [];
      props.columns.forEach(function (item) {
        if (!item.hidden) {
          if (item.fixed || leftFixedType.indexOf(item.type) !== -1) {
            leftFixedColumns.push(item);
          } else if (item.rightFixed) {
            rightFixedColumns.push(item);
          } else {
            normalColumns.push(item);
          }
        }
      });

      columns = leftFixedColumns.concat(normalColumns, rightFixedColumns);
      bodyWrapClassName = 'kuma-uxtable-body-scroll';
    } else {
      bodyWrapClassName = 'kuma-uxtable-body-no';
    }
    var rows = data.map(function (item, index) {
      var renderProps = {
        columns: columns,
        index: index,
        data: data,
        rowIndex: item.jsxid, // tree mode, rowIndex need think more, so use jsxid
        rowData: deepcopy(data[index]),
        isHover: props.currentHoverRow === index,
        root: props.root,
        locale: props.locale,
        subComp: props.subComp,
        actions: props.actions,
        key: 'row' + index,
        mode: props.mode,
        renderModel: props.renderModel,
        fixedColumn: props.fixedColumn,
        level: 1,
        levels: props.levels,
        expandedKeys: props.expandedKeys,
        renderSubComp: props.renderSubComp,
        changeSelected: me.props.changeSelected,
        checkboxColumnKey: props.checkboxColumnKey,
        addRowClassName: props.addRowClassName,
        rowSelection: props.rowSelection,
        handleDataChange: props.handleDataChange,
        attachCellField: props.attachCellField,
        detachCellField: props.detachCellField,
        visible: true,
        last: index === data.length - 1
      };
      return React.createElement(Row, renderProps);
    });
    // const content = util.getIEVer() >= 8 ? rows : <QueueAnim>{rows}</QueueAnim>;
    return React.createElement(
      'div',
      { className: bodyWrapClassName, ref: this.saveRef('root'), style: style },
      this.renderEmptyData(),
      data.length > 0 ? React.createElement(
        'ul',
        { className: this.props.jsxprefixCls },
        rows
      ) : null
    );
  };

  return Tbody;
}(React.Component);

Tbody.propTypes = {
  jsxprefixCls: React.PropTypes.string,
  fixedColumn: React.PropTypes.string,
  data: React.PropTypes.array,
  emptyText: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.object]),
  height: React.PropTypes.oneOfType([React.PropTypes.string, React.PropTypes.number]),
  mask: React.PropTypes.bool,
  onScroll: React.PropTypes.func
};

Tbody.defaultProps = {
  jsxprefixCls: 'kuma-uxtable-body',
  onScroll: function onScroll() {}
};

exports["default"] = Tbody;
module.exports = exports['default'];